import React,{Component} from 'react';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';
import moment from 'moment';
import '@/manageCenter/financialManage/distribute/public.less';
import { Icon, Button,Form, Input, Select, Spin, Table, Switch, message, DatePicker, Modal } from 'antd';
import OrderDesc from '@/manageCenter/financialManage/orderDetail/orderDesc'
import Assign from '@/manageCenter/publicComponent/assign';
import {getProcessStatus,getApproval} from '@/tools';

const PaiDan = React.createClass({
    loadData(pageNo) {
        this.state.data = [];
        this.setState({
            page:pageNo,
            loading: true
        });
       $.ajax({
			method: "get",
			dataType: "json",
			crossDomain: false,
			url: globalConfig.context +"/api/admin/newOrder/orderNewList",
			data: {
				pageNo: pageNo || 1,
				pageSize: this.state.pagination.pageSize,
				specially: 4,//咨询师管理列表
				distribution:2,//全部列表
				name: this.state.customerName,//名称
				orderNo: this.state.orderNo,//订单编号
				starTime: this.state.releaseDate[0],//开始时间
				endTime: this.state.releaseDate[1],//结束时间
			},
            success: function (data) {
                let theArr = [];
                if (!data.data || !data.data.list) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                    for (let i = 0; i < data.data.list.length; i++) {
                        let thisdata = data.data.list[i];
                        theArr.push({
                            key: i,
                            id:thisdata.id,//任务ID
                            orderNo: thisdata.orderNo,//订单编号
	                         totalAmount:thisdata.totalAmount,//签单金额
	                         processStatus:thisdata.processStatus,//流程状态
	                         liquidationStatus:thisdata.liquidationStatus,//结算状态
	                         approval:thisdata.approval,//特批状态
	                         signDate:thisdata.signDate,//签单时间
	                         userName:thisdata.userName,//客户名称
	                         salesmanName:thisdata.salesmanName,//营销员名称
	                         financeName:thisdata.financeName,//财务名称
	                         consultantName:thisdata.consultantName,//项目负责人
	                         createDate:thisdata.createDate,//下单时间
                        });
                    };
                }
                this.state.pagination.current = data.data.pageNo;
                this.state.pagination.total = data.data.totalCount;
                if(data.data&&data.data.list&&!data.data.list.length){
					this.state.pagination.current=0
					this.state.pagination.total=0
				}
                this.setState({
                    dataSource: theArr,
                    pagination: this.state.pagination
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getInitialState() {
        return {
            searchMore: true,
            assignVisible:false,
            releaseDate: [],
            boHuivisible:false,
            selectedRowKeys: [],
            selectedRows: [],
            loading: false,
            pagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.loadData(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            columns: [
                {
                    title: '订单编号',
                    dataIndex: 'orderNo',
                    key: 'orderNo',
                },
                {
                    title: '签单客户',
                    dataIndex: 'userName',
                    key: 'userName',
                }, {
                    title: '下单时间',
                    dataIndex: 'createDate',
                    key: 'createDate',
                },  {
                    title: '签单时间',
                    dataIndex: 'signDate',
                    key: 'signDate',
                },
                {
                    title: '订单总金额(万)',
                    dataIndex: 'totalAmount',
                    key: 'totalAmount'
                },
                {
                    title: '是否特批',
                    dataIndex: 'approval',
                    key: 'approval',
                    render: text => { return getApproval(text)}
                },
                {
                    title: '订单负责人',
                    dataIndex: 'salesmanName',
                    key: 'salesmanName'
                },
                {
                    title: '财务负责人',
                    dataIndex: 'financeName',
                    key: 'financeName'
                },
                {
                    title: '项目负责人',
                    dataIndex: 'consultantName',
                    key: 'consultantName'
                },
                {
                    title: '分派状态',
                    dataIndex: 'processStatus',
                    key: 'processStatus',
                    render: text => { return getProcessStatus(text)}
                },
                {
                    title:'操作',
                    dataIndex: 'caozuo',
                    key: 'caouzo',
                    render:(text,recard)=>{
                        return <div>
                            <Button type="primary" style={{margin:'0 10px'}} onClick={(e)=>{e.stopPropagation(),this.evaluate(recard)}}>分配任务</Button>
                        </div>
                    }
                }
            ],
            dataSource: [],
            searchTime: [,]
        }
    },
    /* 分派 */
    evaluate(recard){
        this.state.assignData=recard;
        this.setState({
            assignVisible:true
        })
    },
   
    componentWillMount() {
        this.loadData();
    },
    tableRowClick(record, index) {
        this.state.RowData = record;
        this.setState({
            showDesc: true,
        });
    },
    closeDesc(e, s) {
        this.state.showDesc = e;
        if (s) {
            this.loadData(this.state.page);
        };
    },
    closeAssign(e, s) {
        this.state.assignVisible = e;
        if (s) {
            this.loadData(this.state.page);
        };
    },
    search() {
        this.loadData();
    },
    reset() {
        this.state.nameSearch = '';
        this.state.releaseDate = [];
        this.state.orderNoSearch=''
        this.state.distribution=undefined;
        this.loadData();
    },
    searchSwitch() {
        this.setState({
            searchMore: !this.state.searchMore
        });
    },
    render() { 
        const rowSelection = {
            selectedRowKeys: this.state.selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
                this.setState({
                    selectedRows: selectedRows.slice(-1),
                    selectedRowKeys: selectedRowKeys.slice(-1)
                });
            }
        };
        const hasSelected = this.state.selectedRowKeys.length > 0;
        const { RangePicker } = DatePicker;
        return ( <div className="user-content">
            <div className="content-title">
                    <span>项目派单管理</span>
                </div>
                <div className="user-search">
                    <Input placeholder="客户名称"
                        value={this.state.nameSearch}
                        onChange={(e) => { this.setState({ nameSearch: e.target.value }); }} />
                    <Input placeholder="订单编号"
                        value={this.state.orderNoSearch}
                        onChange={(e) => { this.setState({ orderNoSearch: e.target.value }); }} />
                    <Select 
                        onChange={(e)=>{this.setState({distribution:e})}} 
                        style={{width:160,marginRight:5}} 
                        placeholder="分派状态"
                        value={this.state.distribution}>
                        <Option value="0">未分配</Option>
                        <Option value="1">已分配</Option>
                    </Select>
                    <Button type="primary" onClick={this.search}>搜索</Button>
                    <Button onClick={this.reset}>重置</Button>
                    <span>更多搜索<Switch defaultChecked={false} onChange={this.searchSwitch.bind(this)} /></span>
                    <div className="search-more" style={this.state.searchMore ? { display: 'none' } : {}}>
                        <span>订单时间 :</span>
                        <RangePicker
                            value={[this.state.releaseDate[0] ? moment(this.state.releaseDate[0]) : null,
                            this.state.releaseDate[1] ? moment(this.state.releaseDate[1]) : null]}
                            onChange={(data, dataString) => { this.setState({ releaseDate: dataString }); }} />
                    </div>
                </div>
                <div className="patent-table">
                    <Spin spinning={this.state.loading}>
                        <Table columns={this.state.columns}
                            dataSource={this.state.dataSource}
                            rowSelection={rowSelection}
                            pagination={this.state.pagination}
                            onRowClick={this.tableRowClick.bind(this)} />
                    </Spin>
                </div>
                <OrderDesc
                    data={this.state.RowData}
                    showDesc={this.state.showDesc}
                    closeDesc={this.closeDesc.bind(this)}
                />
                <Assign
                    title="项目"
                    selApi="/api/admin/financial/distributionFinance"
                    data={this.state.assignData}
                    showDesc={this.state.assignVisible}
                    closeDesc={this.closeAssign.bind(this)}
                    title={'项目'}
                    fenpaiData={8}
                />
        </div> )
    }
})
 
export default PaiDan;